package org.apache.bcel.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.Hashtable;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Utility;

/** @deprecated */
@Deprecated
public class ClassLoader extends java.lang.ClassLoader {
   private static final String BCEL_TOKEN = "$$BCEL$$";
   public static final String[] DEFAULT_IGNORED_PACKAGES = new String[]{"java.", "javax.", "sun."};
   private final Hashtable<String, Class<?>> classes;
   private final String[] ignoredPackages;
   private Repository repository;

   public ClassLoader() {
      this(DEFAULT_IGNORED_PACKAGES);
   }

   public ClassLoader(java.lang.ClassLoader deferTo) {
      super(deferTo);
      this.classes = new Hashtable();
      this.repository = SyntheticRepository.getInstance();
      this.ignoredPackages = DEFAULT_IGNORED_PACKAGES;
      this.repository = new ClassLoaderRepository(deferTo);
   }

   public ClassLoader(java.lang.ClassLoader deferTo, String[] ignoredPackages) {
      this(ignoredPackages);
      this.repository = new ClassLoaderRepository(deferTo);
   }

   public ClassLoader(String[] ignoredPackages) {
      this.classes = new Hashtable();
      this.repository = SyntheticRepository.getInstance();
      this.ignoredPackages = ignoredPackages;
   }

   protected JavaClass createClass(String className) {
      int index = className.indexOf("$$BCEL$$");
      String realName = className.substring(index + "$$BCEL$$".length());
      JavaClass clazz = null;

      try {
         byte[] bytes = Utility.decode(realName, true);
         ClassParser parser = new ClassParser(new ByteArrayInputStream(bytes), "foo");
         clazz = parser.parse();
      } catch (IOException var8) {
         IOException e = var8;
         e.printStackTrace();
         return null;
      }

      ConstantPool cp = clazz.getConstantPool();
      ConstantClass cl = (ConstantClass)cp.getConstant(clazz.getClassNameIndex(), (byte)7, ConstantClass.class);
      ConstantUtf8 name = cp.getConstantUtf8(cl.getNameIndex());
      name.setBytes(className.replace('.', '/'));
      return clazz;
   }

   protected Class<?> loadClass(String className, boolean resolve) throws ClassNotFoundException {
      Class<?> cl = null;
      if ((cl = (Class)this.classes.get(className)) == null) {
         String[] clazz = this.ignoredPackages;
         int var5 = clazz.length;

         for(int var6 = 0; var6 < var5; ++var6) {
            String ignoredPackage = clazz[var6];
            if (className.startsWith(ignoredPackage)) {
               cl = this.getParent().loadClass(className);
               break;
            }
         }

         if (cl == null) {
            clazz = null;
            JavaClass clazz;
            if (className.contains("$$BCEL$$")) {
               clazz = this.createClass(className);
            } else {
               if ((clazz = this.repository.loadClass(className)) == null) {
                  throw new ClassNotFoundException(className);
               }

               clazz = this.modifyClass(clazz);
            }

            if (clazz != null) {
               byte[] bytes = clazz.getBytes();
               cl = this.defineClass(className, bytes, 0, bytes.length);
            } else {
               cl = Class.forName(className);
            }
         }

         if (resolve) {
            this.resolveClass(cl);
         }
      }

      this.classes.put(className, cl);
      return cl;
   }

   protected JavaClass modifyClass(JavaClass clazz) {
      return clazz;
   }
}
